Index: /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90	(revision 5192)
+++ /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90	(revision 5193)
@@ -2687,682 +2672,660 @@
             ENDIF
           ENDIF
-       END DO
-    END DO
-    !PRINT*, 'LAMINE'
-    
+        END DO
+      END DO
+      !PRINT*, 'LAMINE'
+
+      DO i = 1, klon
+        IF (wk_active(i)) THEN
+          !PRINT*, ipas,'xxx1, int_dth(i,ktop1(i)), frac_int_dth(i), int_dth(i,ktop1(i)+1) ',ktop1
+          ddd = int_dth(i, ktop1(i) + 1) - int_dth(i, ktop1(i))
+          IF (ddd==0.) THEN
+            omega(i) = 0.
+          else
+            omega(i) = (frac_int_dth(i) - int_dth(i, ktop1(i))) / ddd
+          endif
+          !! PRINT*,'OMEGA ',omega(i)
+        END IF
+      END DO
+
+      !! PRINT*, 'xxx'
+      DO i = 1, klon
+        IF (wk_active(i)) THEN
+          ! PRINT*, 'xxx, int_dth(i,ktop1(i)), frac_int_dth(i), int_dth(i,ktop1(i)+1) ', &
+          !               int_dth(i,ktop1(i)), frac_int_dth(i), int_dth(i,ktop1(i)+1)
+          ! PRINT*, 'xxx, omega(i), ph(i,ktop1(i)), ph(i,ktop1(i)+1) ',  &
+          !e               omega(i), ph(i,ktop1(i)), ph(i,ktop1(i)+1)
+          ptop1(i) = min((1 - omega(i)) * ph(i, ktop1(i)) + omega(i) * ph(i, ktop1(i) + 1), ph(i, 1))
+        END IF
+      END DO
+
+      DO i = 1, klon
+        IF (wk_active(i)) THEN
+          zzz(i, 1) = 0
+        END IF
+      END DO
+      DO k = 1, klev
+        DO i = 1, klon
+          IF (wk_active(i)) THEN
+            dzz(i, k) = (ph(i, k) - ph(i, k + 1)) / (rho(i, k) * RG)
+            zzz(i, k + 1) = zzz(i, k) + dzz(i, k)
+          END IF
+        END DO
+      END DO
+
+      DO i = 1, klon
+        IF (wk_active(i)) THEN
+          h_zzz(i) = max((1 - omega(i)) * zzz(i, ktop1(i)) + omega(i) * zzz(i, ktop1(i) + 1), hwmin)
+        END IF
+      END DO
+
+    ENDIF ! (iflag_wk_new_ptop/=0)
+
+    !if (iflag_wk_new_ptop==2) THEN
+    IF (iflag_wk_new_ptop>0) THEN
+      DO i = 1, klon
+        ptop(i) = ptop1(i)
+        ktop(i) = ktop1(i)
+        hw_(i) = h_zzz(i)
+      enddo
+
+      !endif
+    ENDIF
+
+    kupper = 0
+
+    IF (wk_pupper<1.) THEN
+      ! Choose an integration bound well above wake top
+      ! -----------------------------------------------------------------
+
+      ! Pupper = 50000.  ! melting level
+      ! Pupper = 60000.
+      ! Pupper = 80000.  ! essais pour case_e
+      DO i = 1, klon
+        !  pupper(i) = 0.6*ph(i, 1)
+        pupper(i) = wk_pupper * ph(i, 1)
+        pupper(i) = max(pupper(i), 45000.)
+        ! cc        Pupper(i) = 60000.
+      END DO
+
+    ELSE
+      DO i = 1, klon
+        ! pupper(i) = wk_pupper*ptop(i)+(1.-wk_pupper)*ph(i, 1)
+        !  pupper(i) = min( wk_pupper*ptop(i)+(1.-wk_pupper)*ph(i, 1) , ptop(i)-50.)
+        pupper(i) = min(wk_pupper * ptop(i) + (1. - wk_pupper) * ph(i, 1), ptop(i) - 5000.)
+      END DO
+    END IF
+
+    ! -5/ Determination de kupper
+
+    DO k = klev, 1, -1
+      DO i = 1, klon
+        IF (ph(i, k + 1)<pupper(i)) kupper(i) = k
+      END DO
+    END DO
+
+    ! On evite kupper = 1 et kupper = klev
     DO i = 1, klon
-       IF (wk_active(i)) THEN
-           !PRINT*, ipas,'xxx1, int_dth(i,ktop1(i)), frac_int_dth(i), int_dth(i,ktop1(i)+1) ',ktop1
-           ddd=int_dth(i,ktop1(i)+1)-int_dth(i,ktop1(i))
-           IF (ddd==0.) THEN
-              omega(i)=0.
-           else
-              omega(i) = (frac_int_dth(i) - int_dth(i,ktop1(i)))/ddd
-           endif
-           !! PRINT*,'OMEGA ',omega(i)
-       END IF
-    END DO
-    
-    !! PRINT*, 'xxx'
-    DO i = 1, klon
-       IF (wk_active(i)) THEN
-      ! PRINT*, 'xxx, int_dth(i,ktop1(i)), frac_int_dth(i), int_dth(i,ktop1(i)+1) ', &
-      !               int_dth(i,ktop1(i)), frac_int_dth(i), int_dth(i,ktop1(i)+1)
-      ! PRINT*, 'xxx, omega(i), ph(i,ktop1(i)), ph(i,ktop1(i)+1) ',  &
-      !e               omega(i), ph(i,ktop1(i)), ph(i,ktop1(i)+1)
-          ptop1(i) = min((1 - omega(i))*ph(i,ktop1(i)) + omega(i)*ph(i,ktop1(i)+1), ph(i,1))
-      END IF
-    END DO
-    
-    DO i=1, klon
-       IF (wk_active(i)) THEN 
-           zzz(i, 1) = 0
-       END IF
-     END DO
-    DO k = 1, klev
-       DO i = 1, klon 
-           IF (wk_active(i)) THEN         
-              dzz(i,k) = (ph(i,k) - ph(i,k+1))/(rho(i,k)*RG)
-              zzz(i,k+1) = zzz(i,k) + dzz(i,k)
-           END IF
-       END DO
-    END DO
-    
-    DO i =1, klon
-       IF (wk_active(i)) THEN
-           h_zzz(i) = max((1- omega(i))*zzz(i,ktop1(i)) + omega(i)*zzz(i,ktop1(i)+1), hwmin)
-       END IF
-    END DO
-
-
-ENDIF ! (iflag_wk_new_ptop/=0)
-
-!if (iflag_wk_new_ptop==2) THEN
-IF (iflag_wk_new_ptop>0) THEN 
-   DO i=1,klon
-      ptop(i)=ptop1(i)
-      ktop(i)=ktop1(i)
-      hw_(i)=h_zzz(i)
-   enddo
-
-!endif
-ENDIF
-
- kupper = 0
- 
-IF (wk_pupper<1.) THEN
- ! Choose an integration bound well above wake top
-  ! -----------------------------------------------------------------
-
-  ! Pupper = 50000.  ! melting level
-  ! Pupper = 60000.
-  ! Pupper = 80000.  ! essais pour case_e
-  DO i = 1, klon
-  !  pupper(i) = 0.6*ph(i, 1)
-    pupper(i) = wk_pupper*ph(i, 1)
-    pupper(i) = max(pupper(i), 45000.)
-    ! cc        Pupper(i) = 60000.
-  END DO
-
-ELSE
-  DO i=1, klon
-     ! pupper(i) = wk_pupper*ptop(i)+(1.-wk_pupper)*ph(i, 1) 
-     !  pupper(i) = min( wk_pupper*ptop(i)+(1.-wk_pupper)*ph(i, 1) , ptop(i)-50.) 
-      pupper(i) = min( wk_pupper*ptop(i)+(1.-wk_pupper)*ph(i, 1) , ptop(i)-5000.) 
-  END DO
-END IF
- 
-  ! -5/ Determination de kupper
-
-  DO k = klev, 1, -1
-    DO i = 1, klon
-      IF (ph(i,k+1)<pupper(i)) kupper(i) = k
-    END DO
-  END DO
-
-  ! On evite kupper = 1 et kupper = klev
-  DO i = 1, klon
-    kupper(i) = max(kupper(i), 2)
-    kupper(i) = min(kupper(i), klev-1)
-  END DO 
-  !---------- FIN nouveau calcul hw et ptop -------------------------------------
-
-IF (iflag_wk_new_ptop==999) THEN
-    DO i = 1, klon
-    hw_(i)=0.
-    ptop(i)=ph(i,1)
-    Ktop(i)=1
-    pupper(i)=ph(i,2)
-    kupper(i)=2
-    h_zzz(i)=0.
-    Ptop1(i)=ph(i,1)
-    ENDDO
-ENDIF
-
-zk_ptop_provis=k_ptop_provis
-
-
-END SUBROUTINE pkupper
-
-
-SUBROUTINE wake_popdyn_1(klon, klev, dtime, cstar, tau_wk_inv, wgen, wdens, awdens, sigmaw, &
-                  wdensmin, &
-                  dtimesub, gfl, rad_wk, f_shear, drdt_pos, &
-                  d_awdens, d_wdens, d_sigmaw, &
-                  iflag_wk_act, wk_adv, cin, wape, &
-                  drdt, &
-                  d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
-                  d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
-                  d_wdens_targ, d_sigmaw_targ)
-                
-
-  USE lmdz_wake_ini , ONLY: wake_ini
-  USE lmdz_wake_ini , ONLY: prt_level,RG
-  USE lmdz_wake_ini , ONLY: stark, wdens_ref
-  USE lmdz_wake_ini , ONLY: tau_cv, rzero, aa0
-!!  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn, wdensmin
-  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn
-  USE lmdz_wake_ini , ONLY: sigmad, cstart, sigmaw_max
-  
-IMPLICIT NONE
-
-  INTEGER, INTENT(IN)                                   :: klon,klev
-  LOGICAL, DIMENSION (klon),        INTENT(IN)          :: wk_adv
-  REAL,                             INTENT(IN)          :: dtime
-  REAL,                             INTENT(IN)          :: dtimesub
-  REAL,                             INTENT(IN)          :: wdensmin
-  REAL, DIMENSION (klon),           INTENT(IN)          :: wgen
-  REAL, DIMENSION (klon),           INTENT(IN)          :: wdens
-  REAL, DIMENSION (klon),           INTENT(IN)          :: awdens
-  REAL, DIMENSION (klon),           INTENT(IN)          :: sigmaw
-  REAL, DIMENSION (klon),           INTENT(IN)          :: cstar
-  REAL, DIMENSION (klon),           INTENT(IN)          :: cin, wape
-  REAL, DIMENSION (klon),           INTENT(IN)          :: f_shear
-  INTEGER,                          INTENT(IN)          :: iflag_wk_act
-
-  ! Tendencies of state variables (2 is appended to the names of fields which are the cumul of fields 
-  !                                 computed at each sub-timestep; e.g. d_wdens2 is the cumul of d_wdens)
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: rad_wk
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: gfl
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw, d_awdens, d_wdens
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: drdt
-  ! Some components of the tendencies of state variables  
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_gen, d_sig_death, d_sig_col, d_sig_bnd
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_spread
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
-  REAL,                             INTENT(OUT)         :: d_wdens_targ, d_sigmaw_targ
- 
-  
-  REAL                                                  :: delta_t_min
-  INTEGER                                               :: i, k
-  REAL                                                  :: wdens0
-  ! IM 080208
-  LOGICAL, DIMENSION (klon)                             :: gwake
-  
-   ! Variables liees a la dynamique de population
-  REAL, DIMENSION(klon)                                 :: act
-  REAL, DIMENSION(klon)                                 :: tau_wk_inv
-  REAL, DIMENSION(klon)                                 :: wape1_act, wape2_act
-  LOGICAL, DIMENSION (klon)                             :: kill_wake
-  REAL                                                  :: drdt_pos
-  REAL                                                  :: tau_wk_inv_min
-  
-     
-
-      IF (iflag_wk_act == 0) THEN
-        act(:) = 0.
-      ELSEIF (iflag_wk_act == 1) THEN
-        act(:) = 1.
-      ELSEIF (iflag_wk_act ==2) THEN
+      kupper(i) = max(kupper(i), 2)
+      kupper(i) = min(kupper(i), klev - 1)
+    END DO
+    !---------- FIN nouveau calcul hw et ptop -------------------------------------
+
+    IF (iflag_wk_new_ptop==999) THEN
+      DO i = 1, klon
+        hw_(i) = 0.
+        ptop(i) = ph(i, 1)
+        Ktop(i) = 1
+        pupper(i) = ph(i, 2)
+        kupper(i) = 2
+        h_zzz(i) = 0.
+        Ptop1(i) = ph(i, 1)
+      ENDDO
+    ENDIF
+
+    zk_ptop_provis = k_ptop_provis
+
+  END SUBROUTINE pkupper
+
+
+  SUBROUTINE wake_popdyn_1(klon, klev, dtime, cstar, tau_wk_inv, wgen, wdens, awdens, sigmaw, &
+          wdensmin, &
+          dtimesub, gfl, rad_wk, f_shear, drdt_pos, &
+          d_awdens, d_wdens, d_sigmaw, &
+          iflag_wk_act, wk_adv, cin, wape, &
+          drdt, &
+          d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+          d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+          d_wdens_targ, d_sigmaw_targ)
+
+    USE lmdz_wake_ini, ONLY: wake_ini
+    USE lmdz_wake_ini, ONLY: prt_level, RG
+    USE lmdz_wake_ini, ONLY: stark, wdens_ref
+    USE lmdz_wake_ini, ONLY: tau_cv, rzero, aa0
+    !!  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn, wdensmin
+    USE lmdz_wake_ini, ONLY: iflag_wk_pop_dyn
+    USE lmdz_wake_ini, ONLY: sigmad, cstart, sigmaw_max
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN) :: klon, klev
+    LOGICAL, DIMENSION (klon), INTENT(IN) :: wk_adv
+    REAL, INTENT(IN) :: dtime
+    REAL, INTENT(IN) :: dtimesub
+    REAL, INTENT(IN) :: wdensmin
+    REAL, DIMENSION (klon), INTENT(IN) :: wgen
+    REAL, DIMENSION (klon), INTENT(IN) :: wdens
+    REAL, DIMENSION (klon), INTENT(IN) :: awdens
+    REAL, DIMENSION (klon), INTENT(IN) :: sigmaw
+    REAL, DIMENSION (klon), INTENT(IN) :: cstar
+    REAL, DIMENSION (klon), INTENT(IN) :: cin, wape
+    REAL, DIMENSION (klon), INTENT(IN) :: f_shear
+    INTEGER, INTENT(IN) :: iflag_wk_act
+
+    ! Tendencies of state variables (2 is appended to the names of fields which are the cumul of fields
+    !                                 computed at each sub-timestep; e.g. d_wdens2 is the cumul of d_wdens)
+    REAL, DIMENSION (klon), INTENT(OUT) :: rad_wk
+    REAL, DIMENSION (klon), INTENT(OUT) :: gfl
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sigmaw, d_awdens, d_wdens
+    REAL, DIMENSION (klon), INTENT(OUT) :: drdt
+    ! Some components of the tendencies of state variables
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sig_gen, d_sig_death, d_sig_col, d_sig_bnd
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sig_spread
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
+    REAL, INTENT(OUT) :: d_wdens_targ, d_sigmaw_targ
+
+    REAL :: delta_t_min
+    INTEGER :: i, k
+    REAL :: wdens0
+    ! IM 080208
+    LOGICAL, DIMENSION (klon) :: gwake
+
+    ! Variables liees a la dynamique de population
+    REAL, DIMENSION(klon) :: act
+    REAL, DIMENSION(klon) :: tau_wk_inv
+    REAL, DIMENSION(klon) :: wape1_act, wape2_act
+    LOGICAL, DIMENSION (klon) :: kill_wake
+    REAL :: drdt_pos
+    REAL :: tau_wk_inv_min
+
+    IF (iflag_wk_act == 0) THEN
+      act(:) = 0.
+    ELSEIF (iflag_wk_act == 1) THEN
+      act(:) = 1.
+    ELSEIF (iflag_wk_act ==2) THEN
       DO i = 1, klon
         IF (wk_adv(i)) THEN
           wape1_act(i) = abs(cin(i))
-          wape2_act(i) = 2.*wape1_act(i) + 1.
-          act(i) = min(1., max(0., (wape(i)-wape1_act(i)) / (wape2_act(i)-wape1_act(i)) ))
+          wape2_act(i) = 2. * wape1_act(i) + 1.
+          act(i) = min(1., max(0., (wape(i) - wape1_act(i)) / (wape2_act(i) - wape1_act(i))))
         ENDIF  ! (wk_adv(i))
       ENDDO
-      ENDIF  ! (iflag_wk_act ==2)
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-          rad_wk(i) = max( sqrt(sigmaw(i)/(3.14*wdens(i))) , rzero)
-          gfl(i)  = 2.*sqrt(3.14*wdens(i)*sigmaw(i))
-        END IF
-      END DO
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-!!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
-          tau_wk_inv(i) = max( (3.*cstar(i))/(rad_wk(i)*((cstar(i)/cstart)**1.5 - 1)), 0.)
-          tau_wk_inv_min = min(tau_wk_inv(i), 1./dtimesub)
-          drdt(i) = (cstar(i) - wgen(i)*(sigmaw(i)/wdens(i)-aa0)/gfl(i)) / &
-                    (1 + 2*f_shear(i)*(2.*sigmaw(i)-aa0*wdens(i)) - 2.*sigmaw(i))
-!!                    (1 - 2*sigmaw(i)*(1.-f_shear(i)))
-          drdt_pos=max(drdt(i),0.)
-
-!!          d_wdens(i) = ( wgen(i)*(1.+2.*(sigmaw(i)-sigmad)) &
-!!                     - wdens(i)*tau_wk_inv_min &
-!!                     - 2.*gfl(i)*wdens(i)*Cstar(i) )*dtimesub
-!jyg+mlt<
-          d_awdens(i) = ( wgen(i) - (1./tau_cv)*(awdens(i) - act(i)*wdens(i)) )*dtimesub
-          d_dens_gen(i) = wgen(i)
-          d_dens_death(i) = - (wdens(i)-awdens(i))*tau_wk_inv_min 
-          d_dens_col(i) =  -2.*wdens(i)*gfl(i)*drdt_pos 
-          d_dens_gen(i) =  d_dens_gen(i)*dtimesub
-          d_dens_death(i) = d_dens_death(i)*dtimesub
-          d_dens_col(i) =  d_dens_col(i)*dtimesub 
-
-          d_wdens(i) = d_dens_gen(i)+d_dens_death(i)+d_dens_col(i)
-!!          d_wdens(i) = ( wgen(i) - (wdens(i)-awdens(i))*tau_wk_inv_min -  &
-!!                         2.*wdens(i)*gfl(i)*drdt_pos )*dtimesub
-!>jyg+mlt
-
-!jyg<
-          d_wdens_targ = max(d_wdens(i), wdensmin-wdens(i))
-!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
-          d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
-          d_wdens(i) = d_wdens_targ
-!!          d_wdens(i) = max(d_wdens(i), wdensmin-wdens(i))
-!>jyg
-
-!jyg+mlt<
-!!          d_sigmaw(i) = ( (1.-2*f_shear(i)*sigmaw(i))*(gfl(i)*Cstar(i)+wgen(i)*sigmad/wdens(i)) &
-!!                      + 2.*f_shear(i)*wgen(i)*sigmaw(i)**2/wdens(i) &
-!!                      - sigmaw(i)*tau_wk_inv_min )*dtimesub
-          d_sig_gen(i) = wgen(i)*aa0
-          d_sig_death(i) = - sigmaw(i)*(1.-awdens(i)/wdens(i))*tau_wk_inv_min
-!!        
-          
-          d_sig_col(i) = - 2*f_shear(i)*sigmaw(i)*gfl(i)*drdt_pos
-          d_sig_col(i) = - 2*f_shear(i)*(2.*sigmaw(i)-wdens(i)*aa0)*gfl(i)*drdt_pos
-          d_sig_spread(i) = gfl(i)*cstar(i)
-          d_sig_gen(i) =  d_sig_gen(i)*dtimesub
-          d_sig_death(i) = d_sig_death(i)*dtimesub
-          d_sig_col(i) =  d_sig_col(i)*dtimesub 
-          d_sig_spread(i) =  d_sig_spread(i)*dtimesub 
-          d_sigmaw(i) =  d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
-!>jyg+mlt
-
-!jyg<
-          d_sigmaw_targ = max(d_sigmaw(i), sigmad-sigmaw(i))
-!!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
-!!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
-          d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
-          d_sigmaw(i) = d_sigmaw_targ
-!!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
-!>jyg
-        ENDIF
-      ENDDO
-
-      IF (prt_level >= 10) THEN
-        PRINT *,'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1) ', &
-                       cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1)
-        PRINT *,'wake, wdens(1), awdens(1), act(1), d_awdens(1) ', &
-                       wdens(1), awdens(1), act(1), d_awdens(1)
-        PRINT *,'wake, wgen, -(wdens-awdens)*tau_wk_inv, -2.*wdens*gfl*drdt_pos, d_wdens ', &
-                       wgen(1), -(wdens(1)-awdens(1))*tau_wk_inv(1), -2.*wdens(1)*gfl(1)*drdt_pos, d_wdens(1)
-        PRINT *,'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
-                       d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
+    ENDIF  ! (iflag_wk_act ==2)
+
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        rad_wk(i) = max(sqrt(sigmaw(i) / (3.14 * wdens(i))), rzero)
+        gfl(i) = 2. * sqrt(3.14 * wdens(i) * sigmaw(i))
+      END IF
+    END DO
+
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        !!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
+        tau_wk_inv(i) = max((3. * cstar(i)) / (rad_wk(i) * ((cstar(i) / cstart)**1.5 - 1)), 0.)
+        tau_wk_inv_min = min(tau_wk_inv(i), 1. / dtimesub)
+        drdt(i) = (cstar(i) - wgen(i) * (sigmaw(i) / wdens(i) - aa0) / gfl(i)) / &
+                (1 + 2 * f_shear(i) * (2. * sigmaw(i) - aa0 * wdens(i)) - 2. * sigmaw(i))
+        !!                    (1 - 2*sigmaw(i)*(1.-f_shear(i)))
+        drdt_pos = max(drdt(i), 0.)
+
+        !!          d_wdens(i) = ( wgen(i)*(1.+2.*(sigmaw(i)-sigmad)) &
+        !!                     - wdens(i)*tau_wk_inv_min &
+        !!                     - 2.*gfl(i)*wdens(i)*Cstar(i) )*dtimesub
+        !jyg+mlt<
+        d_awdens(i) = (wgen(i) - (1. / tau_cv) * (awdens(i) - act(i) * wdens(i))) * dtimesub
+        d_dens_gen(i) = wgen(i)
+        d_dens_death(i) = - (wdens(i) - awdens(i)) * tau_wk_inv_min
+        d_dens_col(i) = -2. * wdens(i) * gfl(i) * drdt_pos
+        d_dens_gen(i) = d_dens_gen(i) * dtimesub
+        d_dens_death(i) = d_dens_death(i) * dtimesub
+        d_dens_col(i) = d_dens_col(i) * dtimesub
+
+        d_wdens(i) = d_dens_gen(i) + d_dens_death(i) + d_dens_col(i)
+        !!          d_wdens(i) = ( wgen(i) - (wdens(i)-awdens(i))*tau_wk_inv_min -  &
+        !!                         2.*wdens(i)*gfl(i)*drdt_pos )*dtimesub
+        !>jyg+mlt
+
+        !jyg<
+        d_wdens_targ = max(d_wdens(i), wdensmin - wdens(i))
+        !!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+        d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
+        d_wdens(i) = d_wdens_targ
+        !!          d_wdens(i) = max(d_wdens(i), wdensmin-wdens(i))
+        !>jyg
+
+        !jyg+mlt<
+        !!          d_sigmaw(i) = ( (1.-2*f_shear(i)*sigmaw(i))*(gfl(i)*Cstar(i)+wgen(i)*sigmad/wdens(i)) &
+        !!                      + 2.*f_shear(i)*wgen(i)*sigmaw(i)**2/wdens(i) &
+        !!                      - sigmaw(i)*tau_wk_inv_min )*dtimesub
+        d_sig_gen(i) = wgen(i) * aa0
+        d_sig_death(i) = - sigmaw(i) * (1. - awdens(i) / wdens(i)) * tau_wk_inv_min
+        !!
+
+        d_sig_col(i) = - 2 * f_shear(i) * sigmaw(i) * gfl(i) * drdt_pos
+        d_sig_col(i) = - 2 * f_shear(i) * (2. * sigmaw(i) - wdens(i) * aa0) * gfl(i) * drdt_pos
+        d_sig_spread(i) = gfl(i) * cstar(i)
+        d_sig_gen(i) = d_sig_gen(i) * dtimesub
+        d_sig_death(i) = d_sig_death(i) * dtimesub
+        d_sig_col(i) = d_sig_col(i) * dtimesub
+        d_sig_spread(i) = d_sig_spread(i) * dtimesub
+        d_sigmaw(i) = d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
+        !>jyg+mlt
+
+        !jyg<
+        d_sigmaw_targ = max(d_sigmaw(i), sigmad - sigmaw(i))
+        !!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
+        !!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
+        d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
+        d_sigmaw(i) = d_sigmaw_targ
+        !!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
+        !>jyg
       ENDIF
-    
-
-    END SUBROUTINE wake_popdyn_1
-    
-    SUBROUTINE wake_popdyn_2( klon, klev, wk_adv, dtimesub, wgen, &
-                             wdensmin, &
-                             sigmaw, wdens, awdens, &   !! states variables
-                             gfl, cstar, cin, wape, rad_wk, &
-                             d_sigmaw, d_wdens, d_awdens, &  !! tendences 
-                             cont_fact, &
-                             d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
-                             d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
-                             d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd )
-                             
-                                             
-
-  USE lmdz_wake_ini , ONLY: wake_ini
-  USE lmdz_wake_ini , ONLY: prt_level,RG
-  USE lmdz_wake_ini , ONLY: stark, wdens_ref
-  USE lmdz_wake_ini , ONLY: tau_cv, rzero, aa0
-!!  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn, wdensmin
-  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn
-  USE lmdz_wake_ini , ONLY: sigmad, cstart, sigmaw_max
-  
-IMPLICIT NONE
-
-  INTEGER, INTENT(IN)                                   :: klon,klev
-  LOGICAL, DIMENSION (klon),        INTENT(IN)          :: wk_adv
-  REAL,                             INTENT(IN)          :: dtimesub
-  REAL,                             INTENT(IN)          :: wdensmin
-  REAL, DIMENSION (klon),           INTENT(IN)          :: wgen      !! B = birth rate of wakes
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: sigmaw    !! sigma = fractional area of wakes 
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: wdens     !! D = number of wakes per unit area 
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: awdens    !! A = number of active wakes per unit area
-  REAL, DIMENSION (klon),           INTENT(IN)          :: cstar     !! C* = spreading velocity of wakes
-  REAL, DIMENSION (klon),           INTENT(IN)          :: cin, wape  ! RM : A Faire disparaitre
-
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: rad_wk    !! r = wake radius
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: gfl       !! Lg = gust front lenght per unit area
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw, d_wdens, d_awdens
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: cont_fact  !! RM facteur de contact = 2 pi * rad * C*
-  ! Some components of the tendencies of state variables  
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd
-
-
-!! internal variables
-  
-  INTEGER                                               :: i, k
-  REAL, DIMENSION (klon)                                :: tau_wk_inv      !! tau = life time of wakes
-  REAL                                                  :: tau_wk_inv_min
-  REAL, DIMENSION (klon)                                :: tau_prime       !! tau_prime = life time of actives wakes
-  REAL                                                  :: d_wdens_targ, d_sigmaw_targ
-  
-
-!! Equations
-!! dD/dt = B - (D-A)/tau - f D^2
-!! dA/dt = B - A/tau_prime + f (D-A)^2 - f A^2
-!! dsigma/dt = B a0 - sigma/D (D-A)/tau + Lg C* - f (D-A)^2 (sigma/D-a0)
-!!
-!! f = 2 (B (a0-sigma/D) + Lg C*) / (2 (D-A)^2 (2 sigma/D-a0) + D (1-2 sigma))
-
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-          rad_wk(i) = max( sqrt(sigmaw(i)/(3.14*wdens(i))) , rzero)
-          gfl(i)  = 2.*sqrt(3.14*wdens(i)*sigmaw(i))
-        END IF
-      END DO
-
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-!!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
-          tau_wk_inv(i) = max( (3.*cstar(i))/(rad_wk(i)*((cstar(i)/cstart)**1.5 - 1)), 0.)
-          tau_wk_inv_min = min(tau_wk_inv(i), 1./dtimesub)
-          tau_prime(i) = tau_cv
-!!          cont_fact(i) = 2.*(wgen(i)*(aa0-sigmaw(i)/wdens(i)) + gfl(i)*cstar(i)) / &
-!!                             (2.*(wdens(i)-awdens(i))**2*(2.*sigmaw(i)/wdens(i) - aa0) + wdens(i)*(1.-2.*sigmaw(i)))
-!!          cont_fact(i) = 2.*3.14*rad_wk(i)*cstar(i)     ! bug
-!!          cont_fact(i) = 4.*3.14*rad_wk(i)*cstar(i)
-          cont_fact(i) = 2.*gfl(i)*cstar(i)/wdens(i)
-
-          d_sig_gen(i) = wgen(i)*aa0
-          d_sig_death(i) = - sigmaw(i)*(1.-awdens(i)/wdens(i))*tau_wk_inv_min
-          d_sig_col(i) = - cont_fact(i)*(wdens(i)-awdens(i))**2*(2.*sigmaw(i)/wdens(i)-aa0)
-          d_sig_spread(i) = gfl(i)*cstar(i)
-
-          d_sig_gen(i) =  d_sig_gen(i)*dtimesub
-          d_sig_death(i) = d_sig_death(i)*dtimesub
-          d_sig_col(i) =  d_sig_col(i)*dtimesub 
-          d_sig_spread(i) =  d_sig_spread(i)*dtimesub 
-          d_sigmaw(i) =  d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
-
-         
-          d_sigmaw_targ = max(d_sigmaw(i), sigmad-sigmaw(i))
-!!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
-!!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
-          d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
-          d_sigmaw(i) = d_sigmaw_targ
-!!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
-         
-         
-          d_dens_gen(i) = wgen(i)
-          d_dens_death(i) = - (wdens(i)-awdens(i))*tau_wk_inv_min 
-          d_dens_col(i) =  - cont_fact(i)*wdens(i)**2
-
-          d_dens_gen(i) =  d_dens_gen(i)*dtimesub
-          d_dens_death(i) = d_dens_death(i)*dtimesub
-          d_dens_col(i) =  d_dens_col(i)*dtimesub 
-          d_wdens(i) = d_dens_gen(i) + d_dens_death(i) + d_dens_col(i)
-
-
-          d_adens_death(i) = -awdens(i)/tau_prime(i)
-          d_adens_icol(i) = cont_fact(i)*(wdens(i)-awdens(i))**2
-          d_adens_acol(i) = - cont_fact(i)*awdens(i)**2
-
-          d_adens_death(i) =  d_adens_death(i)*dtimesub
-          d_adens_icol(i) =   d_adens_icol(i)*dtimesub
-          d_adens_acol(i) =   d_adens_acol(i)*dtimesub
-          d_awdens(i) =   d_dens_gen(i) + d_adens_death(i) + d_adens_icol(i) + d_adens_acol(i)     
-            
-!!
-          d_wdens_targ = max(d_wdens(i), wdensmin-wdens(i))
-!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
-          d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
-          d_wdens(i) = d_wdens_targ
-          
-          d_wdens_targ = min(max(d_awdens(i),-awdens(i)), wdens(i)-awdens(i))
-!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
-          d_adens_bnd(i) = d_wdens_targ - d_awdens(i)
-          d_awdens(i) = d_wdens_targ
-
-
-
-        ENDIF
-      ENDDO
-
-      IF (prt_level >= 10) THEN
-        PRINT *,'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), cont_fact(1) ', &
-                       cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), cont_fact(1)
-        PRINT *,'wake, wdens(1), awdens(1), d_awdens(1) ', &
-                       wdens(1), awdens(1), d_awdens(1)
-        PRINT *,'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
-                       d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
+    ENDDO
+
+    IF (prt_level >= 10) THEN
+      PRINT *, 'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1) ', &
+              cstar(1), cstar(1) / cstart, rad_wk(1), tau_wk_inv(1), drdt(1)
+      PRINT *, 'wake, wdens(1), awdens(1), act(1), d_awdens(1) ', &
+              wdens(1), awdens(1), act(1), d_awdens(1)
+      PRINT *, 'wake, wgen, -(wdens-awdens)*tau_wk_inv, -2.*wdens*gfl*drdt_pos, d_wdens ', &
+              wgen(1), -(wdens(1) - awdens(1)) * tau_wk_inv(1), -2. * wdens(1) * gfl(1) * drdt_pos, d_wdens(1)
+      PRINT *, 'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
+              d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
+    ENDIF
+
+  END SUBROUTINE wake_popdyn_1
+
+  SUBROUTINE wake_popdyn_2(klon, klev, wk_adv, dtimesub, wgen, &
+          wdensmin, &
+          sigmaw, wdens, awdens, &   !! states variables
+          gfl, cstar, cin, wape, rad_wk, &
+          d_sigmaw, d_wdens, d_awdens, &  !! tendences
+          cont_fact, &
+          d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+          d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+          d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd)
+
+    USE lmdz_wake_ini, ONLY: wake_ini
+    USE lmdz_wake_ini, ONLY: prt_level, RG
+    USE lmdz_wake_ini, ONLY: stark, wdens_ref
+    USE lmdz_wake_ini, ONLY: tau_cv, rzero, aa0
+    !!  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn, wdensmin
+    USE lmdz_wake_ini, ONLY: iflag_wk_pop_dyn
+    USE lmdz_wake_ini, ONLY: sigmad, cstart, sigmaw_max
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN) :: klon, klev
+    LOGICAL, DIMENSION (klon), INTENT(IN) :: wk_adv
+    REAL, INTENT(IN) :: dtimesub
+    REAL, INTENT(IN) :: wdensmin
+    REAL, DIMENSION (klon), INTENT(IN) :: wgen      !! B = birth rate of wakes
+    REAL, DIMENSION (klon), INTENT(INOUT) :: sigmaw    !! sigma = fractional area of wakes
+    REAL, DIMENSION (klon), INTENT(INOUT) :: wdens     !! D = number of wakes per unit area
+    REAL, DIMENSION (klon), INTENT(INOUT) :: awdens    !! A = number of active wakes per unit area
+    REAL, DIMENSION (klon), INTENT(IN) :: cstar     !! C* = spreading velocity of wakes
+    REAL, DIMENSION (klon), INTENT(IN) :: cin, wape  ! RM : A Faire disparaitre
+
+    REAL, DIMENSION (klon), INTENT(OUT) :: rad_wk    !! r = wake radius
+    REAL, DIMENSION (klon), INTENT(OUT) :: gfl       !! Lg = gust front lenght per unit area
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sigmaw, d_wdens, d_awdens
+    REAL, DIMENSION (klon), INTENT(OUT) :: cont_fact  !! RM facteur de contact = 2 pi * rad * C*
+    ! Some components of the tendencies of state variables
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd
+
+
+    !! internal variables
+
+    INTEGER :: i, k
+    REAL, DIMENSION (klon) :: tau_wk_inv      !! tau = life time of wakes
+    REAL :: tau_wk_inv_min
+    REAL, DIMENSION (klon) :: tau_prime       !! tau_prime = life time of actives wakes
+    REAL :: d_wdens_targ, d_sigmaw_targ
+
+
+    !! Equations
+    !! dD/dt = B - (D-A)/tau - f D^2
+    !! dA/dt = B - A/tau_prime + f (D-A)^2 - f A^2
+    !! dsigma/dt = B a0 - sigma/D (D-A)/tau + Lg C* - f (D-A)^2 (sigma/D-a0)
+    !!
+    !! f = 2 (B (a0-sigma/D) + Lg C*) / (2 (D-A)^2 (2 sigma/D-a0) + D (1-2 sigma))
+
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        rad_wk(i) = max(sqrt(sigmaw(i) / (3.14 * wdens(i))), rzero)
+        gfl(i) = 2. * sqrt(3.14 * wdens(i) * sigmaw(i))
+      END IF
+    END DO
+
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        !!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
+        tau_wk_inv(i) = max((3. * cstar(i)) / (rad_wk(i) * ((cstar(i) / cstart)**1.5 - 1)), 0.)
+        tau_wk_inv_min = min(tau_wk_inv(i), 1. / dtimesub)
+        tau_prime(i) = tau_cv
+        !!          cont_fact(i) = 2.*(wgen(i)*(aa0-sigmaw(i)/wdens(i)) + gfl(i)*cstar(i)) / &
+        !!                             (2.*(wdens(i)-awdens(i))**2*(2.*sigmaw(i)/wdens(i) - aa0) + wdens(i)*(1.-2.*sigmaw(i)))
+        !!          cont_fact(i) = 2.*3.14*rad_wk(i)*cstar(i)     ! bug
+        !!          cont_fact(i) = 4.*3.14*rad_wk(i)*cstar(i)
+        cont_fact(i) = 2. * gfl(i) * cstar(i) / wdens(i)
+
+        d_sig_gen(i) = wgen(i) * aa0
+        d_sig_death(i) = - sigmaw(i) * (1. - awdens(i) / wdens(i)) * tau_wk_inv_min
+        d_sig_col(i) = - cont_fact(i) * (wdens(i) - awdens(i))**2 * (2. * sigmaw(i) / wdens(i) - aa0)
+        d_sig_spread(i) = gfl(i) * cstar(i)
+
+        d_sig_gen(i) = d_sig_gen(i) * dtimesub
+        d_sig_death(i) = d_sig_death(i) * dtimesub
+        d_sig_col(i) = d_sig_col(i) * dtimesub
+        d_sig_spread(i) = d_sig_spread(i) * dtimesub
+        d_sigmaw(i) = d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
+
+        d_sigmaw_targ = max(d_sigmaw(i), sigmad - sigmaw(i))
+        !!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
+        !!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
+        d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
+        d_sigmaw(i) = d_sigmaw_targ
+        !!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
+
+        d_dens_gen(i) = wgen(i)
+        d_dens_death(i) = - (wdens(i) - awdens(i)) * tau_wk_inv_min
+        d_dens_col(i) = - cont_fact(i) * wdens(i)**2
+
+        d_dens_gen(i) = d_dens_gen(i) * dtimesub
+        d_dens_death(i) = d_dens_death(i) * dtimesub
+        d_dens_col(i) = d_dens_col(i) * dtimesub
+        d_wdens(i) = d_dens_gen(i) + d_dens_death(i) + d_dens_col(i)
+
+        d_adens_death(i) = -awdens(i) / tau_prime(i)
+        d_adens_icol(i) = cont_fact(i) * (wdens(i) - awdens(i))**2
+        d_adens_acol(i) = - cont_fact(i) * awdens(i)**2
+
+        d_adens_death(i) = d_adens_death(i) * dtimesub
+        d_adens_icol(i) = d_adens_icol(i) * dtimesub
+        d_adens_acol(i) = d_adens_acol(i) * dtimesub
+        d_awdens(i) = d_dens_gen(i) + d_adens_death(i) + d_adens_icol(i) + d_adens_acol(i)
+
+        !!
+        d_wdens_targ = max(d_wdens(i), wdensmin - wdens(i))
+        !!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+        d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
+        d_wdens(i) = d_wdens_targ
+
+        d_wdens_targ = min(max(d_awdens(i), -awdens(i)), wdens(i) - awdens(i))
+        !!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+        d_adens_bnd(i) = d_wdens_targ - d_awdens(i)
+        d_awdens(i) = d_wdens_targ
+
       ENDIF
-sigmaw=sigmaw+d_sigmaw
-wdens=wdens+d_wdens
-awdens=awdens+d_awdens
-
-
-    END SUBROUTINE wake_popdyn_2  
-  
-    SUBROUTINE wake_popdyn_3( klon, klev, phys_sub, wk_adv, dtimesub, wgen, &
-                             wdensmin, &
-                             sigmaw, asigmaw, wdens, awdens, &                       !! state variables
-                             gfl, agfl, cstar, cin, wape, &
-                             rad_wk, arad_wk, irad_wk, &
-                             d_sigmaw, d_asigmaw, d_wdens, d_awdens, &               !! tendencies 
-                             d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
-                             d_asig_death, d_asig_aicol, d_asig_iicol, d_asig_spread, d_asig_bnd, &
-                             d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
-                             d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd )
-                             
-                                             
-
-  USE lmdz_wake_ini , ONLY: wake_ini
-  USE lmdz_wake_ini , ONLY: prt_level,RG
-  USE lmdz_wake_ini , ONLY: stark, wdens_ref
-  USE lmdz_wake_ini , ONLY: tau_cv, rzero, aa0
-!!  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn, wdensmin
-  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn
-  USE lmdz_wake_ini , ONLY: sigmad, cstart, sigmaw_max
-  USE lmdz_wake_ini , ONLY: smallestreal
-  
-IMPLICIT NONE
-
-  INTEGER, INTENT(IN)                                   :: klon,klev
-  LOGICAL,                          INTENT(IN)          :: phys_sub 
-  LOGICAL, DIMENSION (klon),        INTENT(IN)          :: wk_adv
-  REAL,                             INTENT(IN)          :: dtimesub
-  REAL,                             INTENT(IN)          :: wdensmin
-  REAL, DIMENSION (klon),           INTENT(IN)          :: wgen      !! B = birth rate of wakes
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: sigmaw    !! sigma = fractional area of wakes 
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: asigmaw   !! sigma = fractional area of active wakes 
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: wdens     !! D = number of wakes per unit area 
-  REAL, DIMENSION (klon),           INTENT(INOUT)       :: awdens    !! A = number of active wakes per unit area
-  REAL, DIMENSION (klon),           INTENT(IN)          :: cstar     !! C* = spreading velocity of wakes
-  REAL, DIMENSION (klon),           INTENT(IN)          :: cin, wape  ! RM : A Faire disparaitre
-
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: rad_wk    !! r = mean wake radius
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: arad_wk    !! r_A = wake radius of active wakes
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: irad_wk    !! r_I = wake radius of inactive wakes
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: gfl       !! Lg = gust front length per unit area
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: agfl      !! LgA = gust front length of active wakes
-                                                                     !!  per unit area
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw, d_asigmaw, d_wdens, d_awdens
-  ! Some components of the tendencies of state variables  
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_asig_death, d_asig_aicol, d_asig_iicol, d_asig_spread, d_asig_bnd
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_adens_death, d_adens_acol, d_adens_icol, d_adens_bnd
-
-
-!! internal variables
-  
-  INTEGER                                               :: i, k
-  REAL, DIMENSION (klon)                                :: iwdens, isigmaw !! inactive wake density and fractional area
-!!  REAL, DIMENSION (klon)                                :: d_arad, d_irad
-  REAL, DIMENSION (klon)                                :: igfl            !! LgI = gust front length of inactive wakes
-                                                                           !!  per unit area
-  REAL, DIMENSION (klon)                                :: s_wk            !! mean area of individual wakes
-  REAL, DIMENSION (klon)                                :: as_wk           !! mean area of individual active wakes
-  REAL, DIMENSION (klon)                                :: is_wk           !! mean area of individual inactive wakes
-  REAL, DIMENSION (klon)                                :: tau_wk_inv      !! tau = life time of wakes
-  REAL                                                  :: tau_wk_inv_min
-  REAL, DIMENSION (klon)                                :: tau_prime       !! tau_prime = life time of actives wakes
-  REAL                                                  :: d_wdens_targ, d_sigmaw_targ
-
-
-!! Equations
-!! ---------
-!! Gust fronts:
-!! Lg_A = 2 pi r_A A
-!! Lg_I = 2 pi r_I I
-!! Lg   = 2 pi r   D
-!!
-!! Areas:
-!! s = pi r^2
-!! s_A = pi r_A^2
-!! s_I = pi r_I^2
-!!
-!! Life expectancy:
-!! tau_I = 3 C* ((C*/C*t)^3/2 - 1) / r_I
-!!
-!! Time deratives:
-!! dD/dt = B - (D-A)/tau_I - 2 Lg C* D
-!! dA/dt = B - A/tau_A     + 2 Lg_I C* (D-A) - 2 Lg_A C* A
-!! dsigma/dt = B a0 - sigma_I/tau_I + Lg C* - 2 Lg_I C* (D-A) (2 s_I - a0)
-!! dsigma_A/dt = B a0 - sigma_A/tau_A + Lg_A C* + (Lg_A I + Lg_I A) C* s_I + 2 Lg_I C* I a0
-!!
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-         iwdens(i) = wdens(i) - awdens(i)
-         isigmaw(i) = sigmaw(i) - asigmaw(i)
-
-         arad_wk(i) = max( sqrt(asigmaw(i)/(3.14*awdens(i))) , rzero)
-         irad_wk(i) = max( sqrt((sigmaw(i)-asigmaw(i))/  &
-                           (3.14*max(smallestreal,(wdens(i)-awdens(i))))), rzero)
-         rad_wk(i) = (awdens(i)*arad_wk(i)+(wdens(i)-awdens(i))*irad_wk(i))/wdens(i)
-
-         s_wk(i) = 3.14*rad_wk(i)**2
-         as_wk(i) = 3.14*arad_wk(i)**2
-         is_wk(i) = 3.14*irad_wk(i)**2
-
-         gfl(i)  = 2.*sqrt(3.14*wdens(i)*sigmaw(i))
-         agfl(i) = 2.*sqrt(3.14*awdens(i)*asigmaw(i))
-         igfl(i) = gfl(i) - agfl(i)
-        ENDIF
-      ENDDO
-
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-          tau_wk_inv(i) = max( (3.*cstar(i))/(irad_wk(i)*((cstar(i)/cstart)**1.5 - 1)), 0.)
-          tau_wk_inv_min = min(tau_wk_inv(i), 1./dtimesub)
-          tau_prime(i) = tau_cv
-
-          d_sig_gen(i) = wgen(i)*aa0
-          d_sig_death(i) = - isigmaw(i)*tau_wk_inv_min
-          d_sig_col(i) = - 2.*igfl(i)*cstar(i)*iwdens(i)*(2.*is_wk(i)-aa0)
-          d_sig_spread(i) = gfl(i)*cstar(i)
-
-          d_sig_gen(i) =  d_sig_gen(i)*dtimesub
-          d_sig_death(i) = d_sig_death(i)*dtimesub
-          d_sig_col(i) =  d_sig_col(i)*dtimesub 
-          d_sig_spread(i) =  d_sig_spread(i)*dtimesub 
-          d_sigmaw(i) =  d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
-#ifdef IOPHYS_WK
-          IF (phys_sub) CALL iophys_ecrit('d_sigmaw0',1,'d_sigmaw0','',d_sigmaw)
-#endif
-
-         
-          d_sigmaw_targ = max(d_sigmaw(i), sigmad-sigmaw(i))
-!!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
-!!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
-          d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
-          d_sigmaw(i) = d_sigmaw_targ
-!!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
-#ifdef IOPHYS_WK
+    ENDDO
+
+    IF (prt_level >= 10) THEN
+      PRINT *, 'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), cont_fact(1) ', &
+              cstar(1), cstar(1) / cstart, rad_wk(1), tau_wk_inv(1), cont_fact(1)
+      PRINT *, 'wake, wdens(1), awdens(1), d_awdens(1) ', &
+              wdens(1), awdens(1), d_awdens(1)
+      PRINT *, 'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
+              d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
+    ENDIF
+    sigmaw = sigmaw + d_sigmaw
+    wdens = wdens + d_wdens
+    awdens = awdens + d_awdens
+
+  END SUBROUTINE wake_popdyn_2
+
+  SUBROUTINE wake_popdyn_3(klon, klev, phys_sub, wk_adv, dtimesub, wgen, &
+          wdensmin, &
+          sigmaw, asigmaw, wdens, awdens, &                       !! state variables
+          gfl, agfl, cstar, cin, wape, &
+          rad_wk, arad_wk, irad_wk, &
+          d_sigmaw, d_asigmaw, d_wdens, d_awdens, &               !! tendencies
+          d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+          d_asig_death, d_asig_aicol, d_asig_iicol, d_asig_spread, d_asig_bnd, &
+          d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+          d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd)
+
+    USE lmdz_wake_ini, ONLY: wake_ini
+    USE lmdz_wake_ini, ONLY: prt_level, RG
+    USE lmdz_wake_ini, ONLY: stark, wdens_ref
+    USE lmdz_wake_ini, ONLY: tau_cv, rzero, aa0
+    !!  USE lmdz_wake_ini , ONLY: iflag_wk_pop_dyn, wdensmin
+    USE lmdz_wake_ini, ONLY: iflag_wk_pop_dyn
+    USE lmdz_wake_ini, ONLY: sigmad, cstart, sigmaw_max
+    USE lmdz_wake_ini, ONLY: smallestreal
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN) :: klon, klev
+    LOGICAL, INTENT(IN) :: phys_sub
+    LOGICAL, DIMENSION (klon), INTENT(IN) :: wk_adv
+    REAL, INTENT(IN) :: dtimesub
+    REAL, INTENT(IN) :: wdensmin
+    REAL, DIMENSION (klon), INTENT(IN) :: wgen      !! B = birth rate of wakes
+    REAL, DIMENSION (klon), INTENT(INOUT) :: sigmaw    !! sigma = fractional area of wakes
+    REAL, DIMENSION (klon), INTENT(INOUT) :: asigmaw   !! sigma = fractional area of active wakes
+    REAL, DIMENSION (klon), INTENT(INOUT) :: wdens     !! D = number of wakes per unit area
+    REAL, DIMENSION (klon), INTENT(INOUT) :: awdens    !! A = number of active wakes per unit area
+    REAL, DIMENSION (klon), INTENT(IN) :: cstar     !! C* = spreading velocity of wakes
+    REAL, DIMENSION (klon), INTENT(IN) :: cin, wape  ! RM : A Faire disparaitre
+
+    REAL, DIMENSION (klon), INTENT(OUT) :: rad_wk    !! r = mean wake radius
+    REAL, DIMENSION (klon), INTENT(OUT) :: arad_wk    !! r_A = wake radius of active wakes
+    REAL, DIMENSION (klon), INTENT(OUT) :: irad_wk    !! r_I = wake radius of inactive wakes
+    REAL, DIMENSION (klon), INTENT(OUT) :: gfl       !! Lg = gust front length per unit area
+    REAL, DIMENSION (klon), INTENT(OUT) :: agfl      !! LgA = gust front length of active wakes
+    !!  per unit area
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sigmaw, d_asigmaw, d_wdens, d_awdens
+    ! Some components of the tendencies of state variables
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_asig_death, d_asig_aicol, d_asig_iicol, d_asig_spread, d_asig_bnd
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
+    REAL, DIMENSION (klon), INTENT(OUT) :: d_adens_death, d_adens_acol, d_adens_icol, d_adens_bnd
+
+
+    !! internal variables
+
+    INTEGER :: i, k
+    REAL, DIMENSION (klon) :: iwdens, isigmaw !! inactive wake density and fractional area
+    !!  REAL, DIMENSION (klon)                                :: d_arad, d_irad
+    REAL, DIMENSION (klon) :: igfl            !! LgI = gust front length of inactive wakes
+    !!  per unit area
+    REAL, DIMENSION (klon) :: s_wk            !! mean area of individual wakes
+    REAL, DIMENSION (klon) :: as_wk           !! mean area of individual active wakes
+    REAL, DIMENSION (klon) :: is_wk           !! mean area of individual inactive wakes
+    REAL, DIMENSION (klon) :: tau_wk_inv      !! tau = life time of wakes
+    REAL :: tau_wk_inv_min
+    REAL, DIMENSION (klon) :: tau_prime       !! tau_prime = life time of actives wakes
+    REAL :: d_wdens_targ, d_sigmaw_targ
+
+
+    !! Equations
+    !! ---------
+    !! Gust fronts:
+    !! Lg_A = 2 pi r_A A
+    !! Lg_I = 2 pi r_I I
+    !! Lg   = 2 pi r   D
+    !!
+    !! Areas:
+    !! s = pi r^2
+    !! s_A = pi r_A^2
+    !! s_I = pi r_I^2
+    !!
+    !! Life expectancy:
+    !! tau_I = 3 C* ((C*/C*t)^3/2 - 1) / r_I
+    !!
+    !! Time deratives:
+    !! dD/dt = B - (D-A)/tau_I - 2 Lg C* D
+    !! dA/dt = B - A/tau_A     + 2 Lg_I C* (D-A) - 2 Lg_A C* A
+    !! dsigma/dt = B a0 - sigma_I/tau_I + Lg C* - 2 Lg_I C* (D-A) (2 s_I - a0)
+    !! dsigma_A/dt = B a0 - sigma_A/tau_A + Lg_A C* + (Lg_A I + Lg_I A) C* s_I + 2 Lg_I C* I a0
+    !!
+
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        iwdens(i) = wdens(i) - awdens(i)
+        isigmaw(i) = sigmaw(i) - asigmaw(i)
+
+        arad_wk(i) = max(sqrt(asigmaw(i) / (3.14 * awdens(i))), rzero)
+        irad_wk(i) = max(sqrt((sigmaw(i) - asigmaw(i)) / &
+                (3.14 * max(smallestreal, (wdens(i) - awdens(i))))), rzero)
+        rad_wk(i) = (awdens(i) * arad_wk(i) + (wdens(i) - awdens(i)) * irad_wk(i)) / wdens(i)
+
+        s_wk(i) = 3.14 * rad_wk(i)**2
+        as_wk(i) = 3.14 * arad_wk(i)**2
+        is_wk(i) = 3.14 * irad_wk(i)**2
+
+        gfl(i) = 2. * sqrt(3.14 * wdens(i) * sigmaw(i))
+        agfl(i) = 2. * sqrt(3.14 * awdens(i) * asigmaw(i))
+        igfl(i) = gfl(i) - agfl(i)
+      ENDIF
+    ENDDO
+
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        tau_wk_inv(i) = max((3. * cstar(i)) / (irad_wk(i) * ((cstar(i) / cstart)**1.5 - 1)), 0.)
+        tau_wk_inv_min = min(tau_wk_inv(i), 1. / dtimesub)
+        tau_prime(i) = tau_cv
+
+        d_sig_gen(i) = wgen(i) * aa0
+        d_sig_death(i) = - isigmaw(i) * tau_wk_inv_min
+        d_sig_col(i) = - 2. * igfl(i) * cstar(i) * iwdens(i) * (2. * is_wk(i) - aa0)
+        d_sig_spread(i) = gfl(i) * cstar(i)
+
+        d_sig_gen(i) = d_sig_gen(i) * dtimesub
+        d_sig_death(i) = d_sig_death(i) * dtimesub
+        d_sig_col(i) = d_sig_col(i) * dtimesub
+        d_sig_spread(i) = d_sig_spread(i) * dtimesub
+        d_sigmaw(i) = d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
+        IF (CPPKEY_IOPHYS_WK) THEN
+          IF (phys_sub) CALL iophys_ecrit('d_sigmaw0', 1, 'd_sigmaw0', '', d_sigmaw)
+        END IF
+
+        d_sigmaw_targ = max(d_sigmaw(i), sigmad - sigmaw(i))
+        !!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
+        !!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
+        d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
+        d_sigmaw(i) = d_sigmaw_targ
+        !!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
+        IF (CPPKEY_IOPHYS_WK) THEN
           IF (phys_sub) THEN
-             CALL iophys_ecrit('tauwk_inv',1,'tau_wk_inv_min','',tau_wk_inv_min)
-             CALL iophys_ecrit('d_sigmaw',1,'d_sigmaw','',d_sigmaw)
-             CALL iophys_ecrit('d_sig_gen',1,'d_sig_gen','',d_sig_gen)
-             CALL iophys_ecrit('d_sig_death',1,'d_sig_death','',d_sig_death)
-             CALL iophys_ecrit('d_sig_col',1,'d_sig_col','',d_sig_col)
-             CALL iophys_ecrit('d_sig_spread',1,'d_sig_spread','',d_sig_spread)
-             CALL iophys_ecrit('d_sig_bnd',1,'d_sig_bnd','',d_sig_bnd)
+            CALL iophys_ecrit('tauwk_inv', 1, 'tau_wk_inv_min', '', tau_wk_inv_min)
+            CALL iophys_ecrit('d_sigmaw', 1, 'd_sigmaw', '', d_sigmaw)
+            CALL iophys_ecrit('d_sig_gen', 1, 'd_sig_gen', '', d_sig_gen)
+            CALL iophys_ecrit('d_sig_death', 1, 'd_sig_death', '', d_sig_death)
+            CALL iophys_ecrit('d_sig_col', 1, 'd_sig_col', '', d_sig_col)
+            CALL iophys_ecrit('d_sig_spread', 1, 'd_sig_spread', '', d_sig_spread)
+            CALL iophys_ecrit('d_sig_bnd', 1, 'd_sig_bnd', '', d_sig_bnd)
           ENDIF
-#endif
-          d_asig_death(i) = - asigmaw(i)/tau_prime(i)
-          d_asig_aicol(i) = (agfl(i)*iwdens(i) + igfl(i)*awdens(i))*cstar(i)*is_wk(i)
-          d_asig_iicol(i) = 2.*igfl(i)*cstar(i)*iwdens(i)*aa0
-          d_asig_spread(i) = agfl(i)*cstar(i)
-
-          d_asig_death(i) = d_asig_death(i)*dtimesub
-          d_asig_aicol(i) =  d_asig_aicol(i)*dtimesub 
-          d_asig_iicol(i) =  d_asig_iicol(i)*dtimesub 
-          d_asig_spread(i) =  d_asig_spread(i)*dtimesub 
-          d_asigmaw(i) =  d_sig_gen(i) + d_asig_death(i) + d_asig_aicol(i) + d_asig_iicol(i) + d_asig_spread(i)
-#ifdef IOPHYS_WK
-          IF (phys_sub) CALL iophys_ecrit('d_asigmaw0',1,'d_asigmaw0','',d_asigmaw)
-#endif
-
-          d_sigmaw_targ = min(max(d_asigmaw(i),-asigmaw(i)), sigmaw(i)-asigmaw(i))
-!!          d_dens_bnd(i) = d_dens_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
-          d_asig_bnd(i) = d_sigmaw_targ - d_asigmaw(i)
-          d_asigmaw(i) = d_sigmaw_targ
-#ifdef IOPHYS_WK
+        END IF
+        d_asig_death(i) = - asigmaw(i) / tau_prime(i)
+        d_asig_aicol(i) = (agfl(i) * iwdens(i) + igfl(i) * awdens(i)) * cstar(i) * is_wk(i)
+        d_asig_iicol(i) = 2. * igfl(i) * cstar(i) * iwdens(i) * aa0
+        d_asig_spread(i) = agfl(i) * cstar(i)
+
+        d_asig_death(i) = d_asig_death(i) * dtimesub
+        d_asig_aicol(i) = d_asig_aicol(i) * dtimesub
+        d_asig_iicol(i) = d_asig_iicol(i) * dtimesub
+        d_asig_spread(i) = d_asig_spread(i) * dtimesub
+        d_asigmaw(i) = d_sig_gen(i) + d_asig_death(i) + d_asig_aicol(i) + d_asig_iicol(i) + d_asig_spread(i)
+        IF (CPPKEY_IOPHYS_WK) THEN
+          IF (phys_sub) CALL iophys_ecrit('d_asigmaw0', 1, 'd_asigmaw0', '', d_asigmaw)
+        END IF
+
+        d_sigmaw_targ = min(max(d_asigmaw(i), -asigmaw(i)), sigmaw(i) - asigmaw(i))
+        !!          d_dens_bnd(i) = d_dens_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
+        d_asig_bnd(i) = d_sigmaw_targ - d_asigmaw(i)
+        d_asigmaw(i) = d_sigmaw_targ
+        IF (CPPKEY_IOPHYS_WK) THEN
           IF (phys_sub) THEN
-             CALL iophys_ecrit('d_asigmaw',1,'d_asigmaw','',d_asigmaw)
-             CALL iophys_ecrit('d_asig_death',1,'d_asig_death','',d_asig_death)
-             CALL iophys_ecrit('d_asig_aicol',1,'d_asig_aicol','',d_asig_aicol)
-             CALL iophys_ecrit('d_asig_iicol',1,'d_asig_iicol','',d_asig_iicol)
-             CALL iophys_ecrit('d_asig_spread',1,'d_asig_spread','',d_asig_spread)
-             CALL iophys_ecrit('d_asig_bnd',1,'d_asig_bnd','',d_asig_bnd)
+            CALL iophys_ecrit('d_asigmaw', 1, 'd_asigmaw', '', d_asigmaw)
+            CALL iophys_ecrit('d_asig_death', 1, 'd_asig_death', '', d_asig_death)
+            CALL iophys_ecrit('d_asig_aicol', 1, 'd_asig_aicol', '', d_asig_aicol)
+            CALL iophys_ecrit('d_asig_iicol', 1, 'd_asig_iicol', '', d_asig_iicol)
+            CALL iophys_ecrit('d_asig_spread', 1, 'd_asig_spread', '', d_asig_spread)
+            CALL iophys_ecrit('d_asig_bnd', 1, 'd_asig_bnd', '', d_asig_bnd)
           ENDIF
-#endif
-          d_dens_gen(i) = wgen(i)
-          d_dens_death(i) = - iwdens(i)*tau_wk_inv_min 
-          d_dens_col(i) =  - 2.*gfl(i)*cstar(i)*wdens(i)
-
-          d_dens_gen(i) =  d_dens_gen(i)*dtimesub
-          d_dens_death(i) = d_dens_death(i)*dtimesub
-          d_dens_col(i) =  d_dens_col(i)*dtimesub 
-          d_wdens(i) = d_dens_gen(i) + d_dens_death(i) + d_dens_col(i)
-!!
-          d_wdens_targ = max(d_wdens(i), wdensmin-wdens(i))
-!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
-          d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
-          d_wdens(i) = d_wdens_targ
-#ifdef IOPHYS_WK
-    IF (phys_sub) THEN 
-        CALL iophys_ecrit('d_wdens',1,'d_wdens','',d_wdens)
-        CALL iophys_ecrit('d_dens_gen',1,'d_dens_gen','',d_dens_gen)
-        CALL iophys_ecrit('d_dens_death',1,'d_dens_death','',d_dens_death)
-        CALL iophys_ecrit('d_dens_col',1,'d_dens_col','',d_dens_col)
+        END IF
+        d_dens_gen(i) = wgen(i)
+        d_dens_death(i) = - iwdens(i) * tau_wk_inv_min
+        d_dens_col(i) = - 2. * gfl(i) * cstar(i) * wdens(i)
+
+        d_dens_gen(i) = d_dens_gen(i) * dtimesub
+        d_dens_death(i) = d_dens_death(i) * dtimesub
+        d_dens_col(i) = d_dens_col(i) * dtimesub
+        d_wdens(i) = d_dens_gen(i) + d_dens_death(i) + d_dens_col(i)
+        !!
+        d_wdens_targ = max(d_wdens(i), wdensmin - wdens(i))
+        !!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+        d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
+        d_wdens(i) = d_wdens_targ
+        IF (CPPKEY_IOPHYS_WK) THEN
+          IF (phys_sub) THEN
+            CALL iophys_ecrit('d_wdens', 1, 'd_wdens', '', d_wdens)
+            CALL iophys_ecrit('d_dens_gen', 1, 'd_dens_gen', '', d_dens_gen)
+            CALL iophys_ecrit('d_dens_death', 1, 'd_dens_death', '', d_dens_death)
+            CALL iophys_ecrit('d_dens_col', 1, 'd_dens_col', '', d_dens_col)
+          ENDIF
+        END IF
+
+        d_adens_death(i) = -awdens(i) / tau_prime(i)
+        d_adens_icol(i) = 2. * igfl(i) * cstar(i) * iwdens(i)
+        d_adens_acol(i) = - 2. * agfl(i) * cstar(i) * awdens(i)
+
+        d_adens_death(i) = d_adens_death(i) * dtimesub
+        d_adens_icol(i) = d_adens_icol(i) * dtimesub
+        d_adens_acol(i) = d_adens_acol(i) * dtimesub
+        d_awdens(i) = d_dens_gen(i) + d_adens_death(i) + d_adens_icol(i) + d_adens_acol(i)
+        IF (CPPKEY_IOPHYS_WK) THEN
+          IF (phys_sub) THEN
+            CALL iophys_ecrit('d_awdens', 1, 'd_awdens', '', d_awdens)
+            CALL iophys_ecrit('d_adens_death', 1, 'd_adens_death', '', d_adens_death)
+            CALL iophys_ecrit('d_adens_icol', 1, 'd_adens_icol', '', d_adens_icol)
+            CALL iophys_ecrit('d_adens_acol', 1, 'd_adens_acol', '', d_adens_acol)
+          ENDIF
+        END IF
+        d_wdens_targ = min(max(d_awdens(i), -awdens(i)), wdens(i) - awdens(i))
+        !!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+        d_adens_bnd(i) = d_wdens_targ - d_awdens(i)
+        d_awdens(i) = d_wdens_targ
+
+        !!          d_irad(i) = (d_sigmaw(i)-d_asigmaw(i)-isigmaw(i)*(d_wdens(i)-awdens(i))/iwdens(i)) / &
+        !!                      max(smallestreal,(2.*3.14*iwdens(i)*irad_wk(i)))
+        !!          d_arad(i) = (d_asigmaw(i)-asigmaw(i)*d_awdens(i)/awdens(i)) / &
+        !!                      max(smallestreal,(2.*3.14*awdens(i)*arad_wk(i)))
+        !!          d_irad(i) = d_irad(i)*dtimesub
+        !!          d_arad(i) = d_arad(i)*dtimesub
+        !!          CALL iophys_ecrit('d_irad',1,'d_irad','m',d_irad)
+        !!          CALL iophys_ecrit('d_airad',1,'d_arad','m',d_arad)
+        !!
+      ENDIF
+    ENDDO
+
+    IF (prt_level >= 10) THEN
+      PRINT *, 'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), gfl(1) ', &
+              cstar(1), cstar(1) / cstart, rad_wk(1), tau_wk_inv(1), gfl(1)
+      PRINT *, 'wake, wdens(1), awdens(1), d_awdens(1) ', &
+              wdens(1), awdens(1), d_awdens(1)
+      PRINT *, 'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
+              d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
     ENDIF
-#endif
-
-          d_adens_death(i) = -awdens(i)/tau_prime(i)
-          d_adens_icol(i) =   2.*igfl(i)*cstar(i)*iwdens(i)
-          d_adens_acol(i)  = - 2.*agfl(i)*cstar(i)*awdens(i)
-
-          d_adens_death(i) =  d_adens_death(i)*dtimesub
-          d_adens_icol(i) =   d_adens_icol(i)*dtimesub
-          d_adens_acol(i)  =   d_adens_acol(i)*dtimesub
-          d_awdens(i) =   d_dens_gen(i) + d_adens_death(i) + d_adens_icol(i) + d_adens_acol(i)     
-#ifdef IOPHYS_WK
-    IF (phys_sub) THEN 
-        CALL iophys_ecrit('d_awdens',1,'d_awdens','',d_awdens)
-        CALL iophys_ecrit('d_adens_death',1,'d_adens_death','',d_adens_death)
-        CALL iophys_ecrit('d_adens_icol',1,'d_adens_icol','',d_adens_icol)
-        CALL iophys_ecrit('d_adens_acol',1,'d_adens_acol','',d_adens_acol)
-    ENDIF
-#endif
-          d_wdens_targ = min(max(d_awdens(i),-awdens(i)), wdens(i)-awdens(i))
-!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
-          d_adens_bnd(i) = d_wdens_targ - d_awdens(i)
-          d_awdens(i) = d_wdens_targ
-
-!!          d_irad(i) = (d_sigmaw(i)-d_asigmaw(i)-isigmaw(i)*(d_wdens(i)-awdens(i))/iwdens(i)) / &
-!!                      max(smallestreal,(2.*3.14*iwdens(i)*irad_wk(i)))
-!!          d_arad(i) = (d_asigmaw(i)-asigmaw(i)*d_awdens(i)/awdens(i)) / &
-!!                      max(smallestreal,(2.*3.14*awdens(i)*arad_wk(i)))
-!!          d_irad(i) = d_irad(i)*dtimesub
-!!          d_arad(i) = d_arad(i)*dtimesub
-!!          CALL iophys_ecrit('d_irad',1,'d_irad','m',d_irad)
-!!          CALL iophys_ecrit('d_airad',1,'d_arad','m',d_arad)
-!!
-        ENDIF
-      ENDDO
-
-      IF (prt_level >= 10) THEN
-        PRINT *,'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), gfl(1) ', &
-                       cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), gfl(1)
-        PRINT *,'wake, wdens(1), awdens(1), d_awdens(1) ', &
-                       wdens(1), awdens(1), d_awdens(1)
-        PRINT *,'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
-                       d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
-      ENDIF
-sigmaw=sigmaw+d_sigmaw
-asigmaw=asigmaw+d_asigmaw
-wdens=wdens+d_wdens
-awdens=awdens+d_awdens
-
-
-    END SUBROUTINE wake_popdyn_3  
+    sigmaw = sigmaw + d_sigmaw
+    asigmaw = asigmaw + d_asigmaw
+    wdens = wdens + d_wdens
+    awdens = awdens + d_awdens
+
+  END SUBROUTINE wake_popdyn_3
 
 END MODULE lmdz_wake
